using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DropDownListLinquify.Types.GeneratedTypes
{
    public partial class Person
    {
        public Address Address { get; set; }

        protected override void OnInitializeComplete()
        {
            // Load the address. 
            if (AddressId != null && AddressId != Guid.Empty)
            {
                Address = new Address();
                Address.Load(AddressId.GetValueOrDefault());
            }

            base.OnInitializeComplete();
        }

        protected override void OnSave()
        {
            if (Address != null)
            {
                // Save the address. 
                Address.Save();

                // Fill in our foreign key. 
                AddressId = Address.AddressId;
            }

            base.OnSave();
        }
    }
}
