using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*
Primary Objects Linquify - Business Class Generator
Copyright (C) 2010 Kory Becker
http://www.primaryobjects.com

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.
*/

namespace DropDownListLinquify.Types.GeneratedTypes
{
    [Serializable]
    public partial class Color : DropDownListLinquify.Types.GeneratedTypes.BaseTypes.Color
    {
		public Color()
		{
		}

		public Color(DropDownListLinquify.Types.GeneratedTypes.BaseTypes.Color color)
		{
			ColorId = color.ColorId;
			PersonId = color.PersonId;
			FloatValue = color.FloatValue;
			Name = color.Name;
			Value = color.Value;

			OnInitializeComplete();
		}
		
        public Color(System.Nullable<int> _ColorId, System.Nullable<global::System.Guid> _PersonId, global::System.Nullable<double> _FloatValue, string _Name, int _Value)
        {
            if (_ColorId != null)
            {
                ColorId = (int)_ColorId;
            }

			PersonId = _PersonId;
			FloatValue = _FloatValue;
			Name = _Name;
			Value = _Value;

        }

        public new List<Color> Find()
        {
            List<Color> finalResults = new List<Color>();

            List<DropDownListLinquify.Types.GeneratedTypes.BaseTypes.Color> results = base.Find();

            return ConvertFromBaseTypes(results);
        }		

        public new List<Color> ToList()
        {
            List<Color> finalResults = new List<Color>();

            List<DropDownListLinquify.Types.GeneratedTypes.BaseTypes.Color> results = base.ToList();

            return ConvertFromBaseTypes(results);
        }
        
        private List<Color> ConvertFromBaseTypes(List<DropDownListLinquify.Types.GeneratedTypes.BaseTypes.Color> baseTypeList)
        {
			List<Color> typeList = new List<Color>();
			
            foreach (DropDownListLinquify.Types.GeneratedTypes.BaseTypes.Color baseType in baseTypeList)
            {
                typeList.Add(new Color(baseType));
            }
            
            return typeList;
        }
    }
}
