using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*
Primary Objects Linquify - Business Class Generator
Copyright (C) 2010 Kory Becker
http://www.primaryobjects.com

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.
*/

namespace DropDownListLinquify.Types.GeneratedTypes
{
    [Serializable]
    public partial class Person : DropDownListLinquify.Types.GeneratedTypes.BaseTypes.Person
    {
		public Person()
		{
		}

		public Person(DropDownListLinquify.Types.GeneratedTypes.BaseTypes.Person person)
		{
			PersonId = person.PersonId;
			AddressId = person.AddressId;
			FirstName = person.FirstName;
			LastName = person.LastName;
			Age = person.Age;
			CreateDate = person.CreateDate;
			Hours = person.Hours;
			Picture = person.Picture;

			OnInitializeComplete();
		}
		
        public Person(System.Nullable<global::System.Guid> _PersonId, System.Nullable<global::System.Guid> _AddressId, string _FirstName, string _LastName, global::System.Nullable<int> _Age, global::System.DateTime _CreateDate, global::System.Nullable<double> _Hours, byte[] _Picture)
        {
            if (_PersonId != null)
            {
                PersonId = (global::System.Guid)_PersonId;
            }

			AddressId = _AddressId;
			FirstName = _FirstName;
			LastName = _LastName;
			Age = _Age;
			CreateDate = _CreateDate;
			Hours = _Hours;
			Picture = _Picture;

        }

        public new List<Person> Find()
        {
            List<Person> finalResults = new List<Person>();

            List<DropDownListLinquify.Types.GeneratedTypes.BaseTypes.Person> results = base.Find();

            return ConvertFromBaseTypes(results);
        }		

        public new List<Person> ToList()
        {
            List<Person> finalResults = new List<Person>();

            List<DropDownListLinquify.Types.GeneratedTypes.BaseTypes.Person> results = base.ToList();

            return ConvertFromBaseTypes(results);
        }
        
        private List<Person> ConvertFromBaseTypes(List<DropDownListLinquify.Types.GeneratedTypes.BaseTypes.Person> baseTypeList)
        {
			List<Person> typeList = new List<Person>();
			
            foreach (DropDownListLinquify.Types.GeneratedTypes.BaseTypes.Person baseType in baseTypeList)
            {
                typeList.Add(new Person(baseType));
            }
            
            return typeList;
        }
    }
}
